
#include "Arduino.h"
#include "nrf.h"
#include "mbed.h"

#define INPUT_PIN 3 // entrée de mesure
#define OUTPUT_PIN 4 // sortie à relier à l'entrée (pour tester)
#define DUREE 1000 // durée en millisecondes de la mesure

uint32_t compteur,t1,t2;
float frequence;
mbed::InterruptIn inter(digitalPinToPinName(INPUT_PIN));
mbed::Timer temps;
mbed::PwmOut pwm(digitalPinToPinName(OUTPUT_PIN));

// gestionnaire d'interruption pour front montant sur INPUT_PIN
void f_rise() {
  compteur += 1;
}

// mesure de fréquence 
float mesure_frequence() {
  temps.start();
  t1 = temps.read_us();
  compteur = 0;
  rtos::ThisThread::sleep_for(DUREE);
  t2 = temps.read_us();
  frequence = 1.0*compteur/(t2-t1)*1e6;
  temps.stop();
}

void setup() {
  Serial.begin(115200);
  pinMode(INPUT_PIN,INPUT);
  pwm.period_us(100); // génération d'un signal carré de 10 kHz
  pwm.write(0.5); // rapport cyclique
  inter.rise(&f_rise); // configuration de l'interruption matérielle
}

void loop() {
   mesure_frequence();                                                                                                    
   Serial.print(frequence); Serial.println(" Hz");
}

    	        